<?php

/**
 * JCH Optimize - Aggregate and minify external resources for optmized downloads
 * 
 * @author Samuel Marshall <sdmarshall73@gmail.com>
 * @copyright Copyright (c) 2010 Samuel Marshall
 * @license GNU/GPLv3, See LICENSE file
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * If LICENSE file missing, see <http://www.gnu.org/licenses/>.
 */

class CodeAlfa_JchOptimize_Helper_Data extends Mage_Core_Helper_Abstract
{

        public static function getAdminObject()
        {
                static $oJchAdmin = NULL;

                if (is_null($oJchAdmin))
                {
                        global $jch_redirect;
                        
                        $session = Mage::getSingleton('core/session');

                        include_once(Mage::getModuleDir('Module', 'CodeAlfa_JchOptimize') . '/lib/jchoptimize/loader.php');

                        if (!defined('JCH_VERSION'))
                        {
                                define('JCH_VERSION', '1.0.0');
                        }

                        $params = JchPlatformPlugin::getPluginParams();
                        $oJchAdmin = new JchOptimizeAdmin($params, TRUE);

                        static $ao_exception = FALSE;

//                        if ($session->getData('jch_ao_exception'))
//                        {
//                                $session->unsetData('jch_ao_exception');
//                        }
//                        else
//                        {
                                try
                                {
                                        $oJchAdmin->getAdminLinks(new JchPlatformHtml($params), '');
                                }
                                catch (RunTimeException $ex)
                                {
                                        $session->addNotice($ex->getMessage());
//                                        $session->setData('jch_ao_exception', 1);
//                                        self::redirect('adminhtml/system_config/edit/section/jchoptimizeconfig');
                                }
                                catch (Exception $ex)
                                {
                                        JchOptimizeLogger::log($ex->getMessage(), $params);

                                        $session->addError($ex->getMessage());
//                                        $session->setData('jch_ao_exception', 1);
//                                        self::redirect('adminhtml/system_config/edit/section/jchoptimizeconfig');
                                }
//                        }
                }

                return $oJchAdmin;
        }
        
        private static function redirect($url)
        {
                Mage::app()->getResponse()->setRedirect($url);
        }

        public static function fixFilePermissions()
        {
                $wds = array(
                        'app/code/community/CodeAlfa',
                        'app/design/adminhtml/default/default/layout/codealfa_jchoptimize.xml',
                        'app/etc/modules/CodeAlfa_JchOptimize.xml',
                        'js/jch_optimize'
                );

                $result = true;

                foreach ($wds as $wd)
                {
                        if (!self::fix($wd))
                        {
                                $result = false;

                                break;
                        }
                }
                
                return $result;
        }
        
        private static function fix($wd)
        {
                $fs = new Varien_Io_File();

                $result = true;

                $cwd = MAGENTO_ROOT . '/' . $wd;

                if (is_dir($cwd))
                {
                        if (!$fs->chmod($cwd, 0755))
                        {
                                return false;
                        }
                        
                        $fs->cd($cwd);

                        $list = $fs->ls();

                        foreach ($list as $list_item)
                        {
                                if (!$list_item['leaf'])
                                {
                                        self::fix($wd . '/' . $list_item['text']);
                                }
                                else
                                {
                                        if (!$fs->chmod($list_item['text'], 0644))
                                        {
                                                $result = false;

                                                break;
                                        }
                                }
                        }
                }
                else
                {
                        if (!$fs->chmod($cwd, 0644))
                        {
                                $result = false;
                        }
                }

                return $result;
        }
}
