<?php

/**
 * JCH Optimize - Aggregate and minify external resources for optmized downloads
 * 
 * @author Samuel Marshall <sdmarshall73@gmail.com>
 * @copyright Copyright (c) 2010 Samuel Marshall
 * @license GNU/GPLv3, See LICENSE file
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * If LICENSE file missing, see <http://www.gnu.org/licenses/>.
 */


class JchPlatformPaths implements JchInterfacePaths
{

        public static function absolutePath($url)
        {
                return MAGENTO_ROOT . DIRECTORY_SEPARATOR . str_replace('/', DIRECTORY_SEPARATOR, $url);
        }

        public static function ajaxUrl($function)
        {
                return Mage::getUrl('jchoptimize/ajax/' . $function);
        }

        public static function assetPath($pathonly=FALSE)
        {
                return self::rewriteBase() . 'js/jch_optimize/assets';
        }

        public static function imageFolder()
        {
                return JchOptimizeHelper::getBaseFolder() . 'js/jch_optimize/images/';
        }

        public static function path2Url($sPath)
        {
                $oUri     = clone JchPlatformUri::getInstance();
                $sUriPath = $oUri->toString(array('scheme', 'user', 'pass', 'host', 'port')) . self::rewriteBase() .
                        JchOptimizeHelper::strReplace(MAGENTO_ROOT . DIRECTORY_SEPARATOR, '', $sPath);

                return $sUriPath;
        }

        public static function rewriteBase()
        {
                return JchOptimizeHelper::getBaseFolder();
        }

        public static function rootPath()
        {
                return MAGENTO_ROOT . '/';
        }

        public static function spriteDir($url = FALSE)
        {
                $path = 'media/jch_optimize/sprites';
                
                if ($url)
                {
                        return self::rewriteBase() . $path. '/';
                }

                return self::rootPath() . $path;
        }

        public static function adminController($name)
        {
                
        }

        public static function backupImagesParentFolder()
        {
             return self::rootPath() . 'var/';   
        }

}
